""" There are four functions below to implement, plus a main program
at the bottom of this file. The main program prints four lines, one that uses
each function. After you implement each function, write the main program code
to print the next line. """

import sys

def order_two(x, y): # 5 points
    """ Return a 2-tuple containing x and y in sorted order, i.e., return
    (a, b) such that a is the smaller of x and y, and b is the larger. If x
    and y are equal, return x first.
    Precondition: x and y are values that can be compared with comparison
    operators.
    Examples:
        order_two(1, 2) => (1, 2)
        order_two(2, 1) => (1, 2)
        order_two(99, 101) => (99, 101)
        order_two("ac", "ab") => ("ab", "ac")
        order_two("a", "B") => ("B", "a") (because of lexicographic string ordering)
    """
    
    
def next_square(n): # 5 points
    """ Return the smallest perfect square greater than n.
    A perfect square is a number that is the square of an integer
    (i.e., an integer times itself). Precondition: n >= 0.
    Examples:
    next_square(3) => 4, (because 2*2=4, but 1*1 = 1, less than 3) 
    next_square(10) => 16 (because 4*4 = 16, but 3*3 = 9, less than 10)
    next_square(4) => 9 (must be strictly greater than n, so 3*3=9 is the next)
    next_square(0) => 1 (0*0 = 0, so 1*1 = 1 is the next perfect square)
    next_square(9000) => 9025 (= 95*95)
    """
    
    

def reverse_substring(string, start, end): # 3 points
    """ Return string, but with string[start:end] replaced by its reverse.
    Precondition: 0 <= start <= end <= len(string).
    Examples:
        reverse_substring("0123456", 0, 3) => "2103456" (012 is reversed)
        reverse_substring("0123456", 4, 6) => "0123546" (45 is reversed)
        reverse_substring("0123456", 6, 7) => "0123456" (6 is reversed)
        reverse_substring("0123456", 0, 7) => "6543210" (whole string reversed)
        reverse_substring("1", 0, 0) => "1" (reverse an empty range)
        reverse_substring("", 0, 0) => "" (reverse nothing in an empty string)
    """
    


def find_all(query, string): # 3 points
    """ Return a list of places in string where where the substring
    query appears. Each element of the returned list is an index
    of the beginning of the substring. Overlapping copies of the query
    are not considered. Pre: query's length is at least 1
    find_all('a', 'abab') => [0, 2]
    find_all('ab', 'abbab') => [0, 3]
    find_all('bb', 'bbb') => [0] (overlapping occurrences are not counted)
    find_all('z', 'the quick brown fox') => [] (none found)
    find_all('q', '') => [] (nothing found in the empty string)
    find_all('abcdef', 'abc') => [] (query is longer than the string)
    """
    

""" Main program: 4 points
Takes 2 positive integers as command line arguments and prints the following
three lines:
- Line 1: The larger of the two arguments
- Line 2: The next perfect square larger than the smaller argument.
- Line 3: The number from line 2, with all its digits reversed.
- Line 4: A list of the indices of occurences of the digit 0 in Line 3.

Example runs:
>>> %Run exam3_practice.py 10 4
10
9
9
[]
>>> %Run exam3_practice.py 200 300
300
225
522
[]
>>> %Run exam3_practice.py 2200 50000
50000
2209
9022
[1]
>>> %Run exam3_practice.py 599004 12001
599004
12100
00121
[0, 1]
>>>"""

# write your main program code here