# Practice exam 3 - main program tests (4 points)
import pytest
import subprocess

def run_with_args(filename, *args):
    args = [str(a) for a in args]
    try:
        command = ["python3", filename + ".py", *args]
        return subprocess.check_output(command, text=True).rstrip("\n")
    except:
        command = ["python", filename + ".py", *args]
        return subprocess.check_output(command, text=True).rstrip("\n")

test_cases = [ # ((arg1, arg2), [line1, line2, line, line4])
        ((10, 4), ["10", "9", "9", "[]"]),
        ((2200, 50000), ["50000", "2209", "9022", "[1]"]),
        ((599004, 12001), ["599004", "12100", "00121", "[0, 1]"]),
        ((2200, 50000), ["50000", "2209", "9022", "[1]"]),
        ((200, 300), ["300", "225", "522", "[]"])
]


def test_main_guard(capsys):
    import importlib

    if 'exam3_practice' in importlib.sys.modules:
        del importlib.sys.modules['exam3_practice']

    import exam3_practice # The import happens here

    captured = capsys.readouterr()
    assert captured.out == "", "Importing exam3_practice produced output; check your main guard."
    assert captured.err == "", "Importing exam3_practice produced output; check your main guard."
    

@pytest.mark.parametrize("args, output_lines", test_cases)
def test_main_program_line1(args, output_lines):
    outputs = run_with_args("exam3_practice", *args).split('\n')
    assert outputs[0].strip() == output_lines[0]

@pytest.mark.parametrize("args, output_lines", test_cases)
def test_main_program_line2(args, output_lines):
    outputs = run_with_args("exam3_practice", *args).split('\n')
    assert outputs[1].strip() == output_lines[1]

@pytest.mark.parametrize("args, output_lines", test_cases)
def test_main_program_line3(args, output_lines):
    outputs = run_with_args("exam3_practice", *args).split('\n')
    assert outputs[2].strip() == output_lines[2]

@pytest.mark.parametrize("args, output_lines", test_cases)
def test_main_program_line4(args, output_lines):
    outputs = run_with_args("exam3_practice", *args).split('\n')
    assert outputs[3].strip() == output_lines[3]

pytest.main(["test_main.py",  "-vv", "--showlocals", "-p", "no:faulthandler"])



